package org.netkernel.layer0.meta.impl;

import org.netkernel.layer0.meta.IEndpointArgumentMeta;
import org.netkernel.layer0.meta.IEndpointMeta;
import org.netkernel.layer0.meta.IIdentifierGrammar;
import org.netkernel.urii.IIdentifier;
import org.netkernel.urii.IMetaRepresentation;


public class EndpointMetaImpl extends MetaRepresentationImpl implements IEndpointMeta
{
	private final int mVerbs;
	private final IIdentifierGrammar mGrammar;
	private final IEndpointArgumentMeta[] mParts;
	private final Class[] mResponseClasses;
	private final IMetaRepresentation[] mExceptions;
	
	public static final IEndpointArgumentMeta[] NO_ARGS=new IEndpointArgumentMeta[0];
	public static final Class[] NO_RESPONSES=new Class[0];
	public static final IMetaRepresentation[] NO_EXCEPTIONS=new IMetaRepresentation[0];
	
	public EndpointMetaImpl(String aName, String aDescription, IIdentifier aIcon, IIdentifier aDoc,
			int aVerbs, IIdentifierGrammar aGrammar, IEndpointArgumentMeta[] aParts, Class[] aResponseClasses, IMetaRepresentation[] aExceptions)
	{	super(aName,aDescription,aIcon,aDoc);
		mVerbs=aVerbs;
		mGrammar=aGrammar;
		mParts=aParts;
		mResponseClasses=aResponseClasses;
		mExceptions = aExceptions;
	}

	public int getSupportedVerbs()
	{	return mVerbs;
	}

	public IIdentifierGrammar getIdentifierGrammar()
	{	return mGrammar;
	}

	public IEndpointArgumentMeta[] getArguments()
	{	return mParts;
	}

	public Class[] getResponseClasses()
	{	return mResponseClasses;
	}

	public IMetaRepresentation[] getExceptions()
	{	return mExceptions;
	}
}